def prod(debut, fin):
    """
    Calcul le produit des nombres entre 
    debut et fin (non inclu). 

    Arguments:
        debut   (int)
        fin     (int)

    Retourne:
        un entier (int)
    """
    accu = 1
    for i in range(debut, fin):
        accu = accu * i
    return accu

def prod2(debut, fin):
    """
    Calcul le produit des nombres entre 
    debut et fin. 

    Arguments:
        debut   (int)
        fin     (int)

    Retourne:
        un entier (int)
    """
    accu = 1
    for i in range(fin - debut):
        accu = accu * (i + debut)
    return accu

def arrangements(k, n):
    """
    Retourne le nombre d'arrangements possible 
    de k éléments parmi n.

    Arguments:
        k (int) 
        n (int)

    Retourne: 
       un entier (int)
    """
    return prod(n-k+1, n+1)


def combinaisons(k, n):
    """
    Retourne le nombre de combinaison possibles
    de k éléments parmi n.

    Arguments:
        k (int) 
        n (int)
    Retourne: 
       un entier (int)
    """
    # Dans la ligne du dessous on utilise la division entière '//' 
    # et non pas la division '/' qui retourne un objet de type 'float'.
    return arrangements(k, n)//prod(1, k+1)


print("Testes pour la fonction prod:")
print(prod(1, 5)) # retourne 1*2*3*4 (24)) 
print(prod(10, 20)) # retourne 335221286400
print(prod(5, 120)) # retourne  2322744067169835783884763213225823814844703587895149239685996997326956096265612149085720196274994785176443624268477114775185558537988931201353639275829739585404500180992000000000000000000000000000
print("Testes pour la fonction arrangements:")
print(arrangements(1, 5)) # retourne 5
print(arrangements(10, 20)) # retourne 670442572800 
print(arrangements(5, 120)) # retourne 22869362880
print("Testes pour la fonction combinaisons:")
print(combinaisons(1, 5)) # retourne 5
print(combinaisons(10, 20)) # retourne 184756
print(combinaisons(5, 120)) # retourne 190578024
